;(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    define([], factory);
  } else if (typeof exports === 'object') {
    module.exports = factory();
  } else {
    root.Darkness = factory();
  }
}(this, function() {
var Darkness = (function() {
  var instance,
    element,
    body = document.querySelector('body');

  function createInstance() {
    createDarkness();
    return Darkness;
  }

  function createDarkness() {
    element = document.createElement('div');
    element.classList.add('c-darkness');
    body.appendChild(element);
  }

  return {
    body: body,
    isOpened: false,
    iCallThy: function iCallThy() {
      if (!instance) {
        instance = createInstance();
        this.itself = element;
        return instance;
      } else {
        throw 'Do not try to create more instances';
        return false;
      }
    },
    summon: function summon(invisibleOverlay) {
      if (!this.isOpened) {
        this.topOffset = window.pageYOffset || document.documentElement.scrollTop;

        if (typeof invisibleOverlay !== 'undefined' && invisibleOverlay === true) {
          this.body.classList.add('darkness-is-invisible');
        }
        this.body.classList.add('darkness-has-come');
        this.body.style.top = -this.topOffset + 'px';
        this.isOpened = true;
      }
    },

    dismiss: function dismiss() {
      const shouldClose = true;
      this.body.classList.forEach(className => {
        if (className.search('-is-opened') > 0) {
          shouldClose = false;
        }
      });
      if (this.isOpened && shouldClose === true) {
        this.body.classList.remove('darkness-has-come');
        this.body.classList.remove('darkness-is-invisible');
        this.body.removeAttribute('style');
        window.scrollTo(0, this.topOffset);
        this.isOpened = false;
      }
    },
    begone: function begone() {
      this.body.classList.remove('darkness-has-come');
      this.body.classList.remove('darkness-is-invisible');
      this.isOpened = false;
    },
  };
})();

return Darkness;
}));
